Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -4476,405 +4106,140 @@
  * Returns:
  *      0 = failed to get slot.
  */
-STATIC request_t *
-qla1280_req_pkt(scsi_qla_host_t *ha)
+static request_t *
+qla1280_req_pkt(struct scsi_qla_host *ha)
 {
-    device_reg_t    *reg = ha->iobase;
-    request_t       *pkt = 0;
-    uint16_t        cnt;
-    uint32_t        *dword_ptr;
-    uint32_t        timer;
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_req_pkt");
-#endif
-
-    /* Wait for 30 seconds for slot. */
-    for (timer = 15000000; timer; timer--)
-    {
-        /* Acquire ring specific lock */
-        QLA1280_RING_LOCK(ha);
-
-        if (ha->req_q_cnt > 0)
-        {
-            /* Calculate number of free request entries. */
-            cnt = RD_REG_WORD(&reg->mailbox4);
-            if (ha->req_ring_index < cnt)
-                ha->req_q_cnt = cnt - ha->req_ring_index;
-            else
-                ha->req_q_cnt = REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
-        }
-
-        /* Found empty request ring slot? */
-        if (ha->req_q_cnt > 0)
-        {
-            ha->req_q_cnt--;
-            pkt = ha->request_ring_ptr;
-
-            /* Zero out packet. */
-            dword_ptr = (uint32_t *)pkt;
-            for (cnt = 0; cnt < REQUEST_ENTRY_SIZE/4; cnt++)
-                *dword_ptr++ = 0;
-
-            /* Set system defined field. */
-            pkt->sys_define = (uint8_t)ha->req_ring_index;
-
-            /* Set entry count. */
-            pkt->entry_count = 1;
-
-            break;
-        }
-
-        /* Release ring specific lock */
-        QLA1280_RING_UNLOCK(ha);
-
-        SYS_DELAY(2);   /* 10 */ 
-
-        /* Check for pending interrupts. */
-        qla1280_poll(ha);
-    }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_req_pkt: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_req_pkt: exiting normally\n\r");
-#endif
-    return(pkt);
-}
-
-/*
- * qla1280_isp_cmd
- *      Function is responsible for modifying ISP input pointer.
- *      Releases ring lock.
- *
- * Input:
- *      ha  = adapter block pointer.
- */
-STATIC void
-qla1280_isp_cmd(scsi_qla_host_t *ha)
-{
-    device_reg_t    *reg = ha->iobase;
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_isp_cmd");
-#endif
-
-#ifdef QL_DEBUG_LEVEL_5
-    qla1280_print("qla1280_isp_cmd: IOCB data:\n\r");
-    qla1280_dump_buffer((caddr_t)ha->request_ring_ptr, REQUEST_ENTRY_SIZE); 
-#endif
-
-    /* Adjust ring index. */
-    ha->req_ring_index++;
-    if (ha->req_ring_index == REQUEST_ENTRY_CNT)
-    {
-        ha->req_ring_index = 0;
-        ha->request_ring_ptr = ha->request_ring;
-    }
-    else
-        ha->request_ring_ptr++;
-
-    /* Set chip new ring index. */
-    WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);
+	struct device_reg *reg = ha->iobase;
+	request_t *pkt = 0;
+	int cnt;
+	uint32_t timer;
+
+	ENTER("qla1280_req_pkt");
+
+	/*
+	 * This can be called from interrupt context, damn it!!!
+	 */
+	/* Wait for 30 seconds for slot. */
+	for (timer = 15000000; timer; timer--) {
+		if (ha->req_q_cnt > 0) {
+			/* Calculate number of free request entries. */
+			cnt = RD_REG_WORD(&reg->mailbox4);
+			if (ha->req_ring_index < cnt)
+				ha->req_q_cnt = cnt - ha->req_ring_index;
+			else
+				ha->req_q_cnt =
+					REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
+		}
 
-    /* Release ring specific lock */
-    QLA1280_RING_UNLOCK(ha);
+		/* Found empty request ring slot? */
+		if (ha->req_q_cnt > 0) {
+			ha->req_q_cnt--;
+			pkt = ha->request_ring_ptr;
+
+			/* Zero out packet. */
+			memset(pkt, 0, REQUEST_ENTRY_SIZE);
+
+			/*
+			 * How can this be right when we have a ring
+			 * size of 512???
+			 */
+			/* Set system defined field. */
+			pkt->sys_define = (uint8_t) ha->req_ring_index;
 
-#ifdef QL_DEBUG_LEVEL_3
-    LEAVE("qla1280_isp_cmd");
-#endif
-}
+			/* Set entry count. */
+			pkt->entry_count = 1;
 
-/*
- * qla1280_enable_lun
- *      Issue enable LUN entry IOCB.
- *
- * Input:
- *      ha = adapter block pointer.
- *      b  = SCSI BUS number.
- *      l  = LUN number.
- */
-STATIC void
-qla1280_enable_lun(scsi_qla_host_t *ha, uint8_t b, uint32_t l)
-{
-    elun_entry_t    *pkt;
+			break;
+		}
 
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_enable_lun: entered\n\r");
-#endif
+		udelay(2);	/* 10 */
 
-    /* Get request packet. */
-    /*
-    if (pkt = (elun_entry_t *)qla1280_req_pkt(ha))
-    {
-    pkt->entry_type = ENABLE_LUN_TYPE;
-    pkt->lun = (uint16_t)(b ? l | BIT_15 : l);
-    pkt->command_count = 32;
-    pkt->immed_notify_count = 1;
-    pkt->group_6_length = MAX_CMDSZ;
-    pkt->group_7_length = MAX_CMDSZ;
-    pkt->timeout = 0x30;
+		/* Check for pending interrupts. */
+		qla1280_poll(ha);
+	}
 
-    qla1280_isp_cmd(ha);
-    }
-    */
-    pkt = (elun_entry_t *)1;
+	if (!pkt)
+		dprintk(2, "qla1280_req_pkt: **** FAILED ****\n");
+	else
+		dprintk(3, "qla1280_req_pkt: exiting normally\n");
 
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_enable_lun: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_enable_lun: exiting normally\n\r");
-#endif
+	return pkt;
 }
 
-#if QL1280_TARGET_MODE_SUPPORT
-/****************************************************************************/
-/*                      Target Mode Support Functions.                      */
-/****************************************************************************/
-
 /*
- * qla1280_notify_ack
- *      Issue notify acknowledge IOCB.
- *      If sequence ID is zero, acknowledgement of
- *      SCSI bus reset or bus device reset is assumed.
+ * qla1280_isp_cmd
+ *      Function is responsible for modifying ISP input pointer.
+ *      Releases ring lock.
  *
  * Input:
- *      ha      = adapter block pointer.
- *      inotify = immediate notify entry pointer.
+ *      ha  = adapter block pointer.
  */
-STATIC void
-qla1280_notify_ack(scsi_qla_host_t *ha, notify_entry_t *inotify)
+static void
+qla1280_isp_cmd(struct scsi_qla_host *ha)
 {
-    nack_entry_t    *pkt;
-
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_notify_ack: entered\n\r");
-#endif
-
-    /* Get request packet. */
-    if (pkt = (nack_entry_t *)qla1280_req_pkt(ha))
-    {
-        pkt->entry_type = NOTIFY_ACK_TYPE;
-        pkt->lun = inotify->lun;
-        pkt->initiator_id = inotify->initiator_id;
-        pkt->target_id = inotify->target_id;
-        if (inotify->seq_id == 0)
-            pkt->event = BIT_7;
-        else
-            pkt->seq_id = inotify->seq_id;
-
-        /* Issue command to ISP */
-        qla1280_isp_cmd(ha);
-    }
+	struct device_reg *reg = ha->iobase;
 
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_notify_ack: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_notify_ack: exiting normally\n\r");
-#endif
-}
-
-/*
- * qla1280_immed_notify
- *      Issue immediate notify IOCB for LUN 0.
- *
- * Input:
- *      ha      = adapter block pointer.
- *      inotify = immediate notify entry pointer.
- */
-STATIC void
-qla1280_immed_notify(scsi_qla_host_t *ha, notify_entry_t *inotify)
-{
-    notify_entry_t    *pkt;
+	ENTER("qla1280_isp_cmd");
 
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_immed_notify: entered\n\r");
-#endif
+	dprintk(5, "qla1280_isp_cmd: IOCB data:\n");
+	qla1280_dump_buffer(5, (char *)ha->request_ring_ptr,
+			    REQUEST_ENTRY_SIZE);
 
-    /* Get request packet. */
-    if (pkt = (notify_entry_t *)qla1280_req_pkt(ha))
-    {
-        pkt->entry_type = IMMED_NOTIFY_TYPE;
-        pkt->lun = inotify->lun;
-        pkt->initiator_id = inotify->initiator_id;
-        pkt->target_id = inotify->target_id;
-        pkt->status = 1;
+	/* Adjust ring index. */
+	ha->req_ring_index++;
+	if (ha->req_ring_index == REQUEST_ENTRY_CNT) {
+		ha->req_ring_index = 0;
+		ha->request_ring_ptr = ha->request_ring;
+	} else
+		ha->request_ring_ptr++;
 
-        /* Issue command to ISP */
-        qla1280_isp_cmd(ha);
-    }
+	/* Set chip new ring index. */
+	WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);
 
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_immed_notify: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_immed_notify: exiting normally\n\r");
-#endif
+	LEAVE("qla1280_isp_cmd");
 }
 
+#if QL1280_LUN_SUPPORT
 /*
- * qla1280_accept_io
- *      Issue accept target I/O IOCB for LUN 0.
+ * qla1280_enable_lun
+ *      Issue enable LUN entry IOCB.
  *
  * Input:
- *      ha = adapter block pointer.
- *      ctio = ctio returned entry pointer.
+ *      ha  = adapter block pointer.
+ *      bus = SCSI BUS number.
+ *      lun  = LUN number.
  */
-STATIC void
-qla1280_accept_io(scsi_qla_host_t *ha, ctio_ret_entry_t *ctio)
+static void
+qla1280_enable_lun(struct scsi_qla_host *ha, int bus, int lun)
 {
-    atio_entry_t    *pkt;
-
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_accept_io: entered\n\r");
-#endif
+	struct elun_entry *pkt;
 
-    /* Get request packet. */
-    if (pkt = (atio_entry_t *)qla1280_req_pkt(ha))
-    {
-        pkt->entry_type = ACCEPT_TGT_IO_TYPE;
-        pkt->lun = ctio->lun;
-        pkt->initiator_id = ctio->initiator_id;
-        pkt->target_id = ctio->target_id;
-        pkt->tag_value = ctio->tag_value;
-        pkt->status = 1;
+	ENTER("qla1280_enable_lun");
+
+	/* Get request packet. */
+	/*
+	  if (pkt = (struct elun_entry *)qla1280_req_pkt(ha))
+	  {
+	  pkt->entry_type = ENABLE_LUN_TYPE;
+	  pkt->lun = cpu_to_le16(bus ? lun | BIT_15 : lun);
+	  pkt->command_count = 32;
+	  pkt->immed_notify_count = 1;
+	  pkt->group_6_length = MAX_CMDSZ;
+	  pkt->group_7_length = MAX_CMDSZ;
+	  pkt->timeout = cpu_to_le16(0x30);
+
+	  qla1280_isp_cmd(ha);
+	  }
+	*/
+	pkt = (struct elun_entry *) 1;
 
-        /* Issue command to ISP */
-        qla1280_isp_cmd(ha);
-    }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_accept_io: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_accept_io: exiting normally\n\r");
-#endif
+	if (!pkt)
+		dprintk(2, "qla1280_enable_lun: **** FAILED ****\n");
+	else
+		dprintk(3, "qla1280_enable_lun: exiting normally\n");
 }
-
-/*
- * qla1280_64bit_continue_io
- *      Issue continue target I/O IOCB.
- *
- * Input:
- *      ha   = adapter block pointer.
- *      atio = atio pointer.
- *      len  = total bytecount.
- *      addr = physical address pointer.
- */
-STATIC void
-qla1280_64bit_continue_io(scsi_qla_host_t *ha, atio_entry_t *atio, uint32_t len,
-                    paddr32_t *addr)
-{
-    ctio_a64_entry_t *pkt;
-    uint32_t         *dword_ptr;
-
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_64bit_continue_io: entered\n\r");
-#endif
-
-    /* Get request packet. */
-    if (pkt = (ctio_a64_entry_t *)qla1280_req_pkt(ha))
-    {
-        pkt->entry_type = CTIO_A64_TYPE;
-        pkt->lun = atio->lun;
-        pkt->initiator_id = atio->initiator_id;
-        pkt->target_id = atio->target_id;
-        pkt->option_flags = atio->option_flags;
-        pkt->tag_value = atio->tag_value;
-        pkt->scsi_status = atio->scsi_status;
-
-        if (len)
-        {
-            pkt->dseg_count = 1;
-            pkt->transfer_length = len;
-            pkt->dseg_0_length = len;
-            dword_ptr = (uint32_t *)addr;
-            pkt->dseg_0_address[0] = *dword_ptr++;
-            pkt->dseg_0_address[1] = *dword_ptr;
-        }
-
-        /* Issue command to ISP */
-        qla1280_isp_cmd(ha);
-    }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_64bit_continue_io: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_64bit_continue_io: exiting normally\n\r");
 #endif
-}
 
-/*
- * qla1280_32bit_continue_io
- *      Issue continue target I/O IOCB.
- *
- * Input:
- *      ha   = adapter block pointer.
- *      atio = atio pointer.
- *      len  = total bytecount.
- *      addr = physical address pointer.
- */
-STATIC void
-qla1280_32bit_continue_io(scsi_qla_host_t *ha, atio_entry_t *atio, uint32_t len,
-                    paddr32_t *addr)
-{
-    ctio_entry_t *pkt;
-    uint32_t     *dword_ptr;
-
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_32bit_continue_io: entered\n\r");
-#endif
-
-    /* Get request packet. */
-    if (pkt = (ctio_entry_t *)qla1280_req_pkt(ha))
-    {
-        pkt->entry_type = CONTINUE_TGT_IO_TYPE;
-        pkt->lun = atio->lun;
-        pkt->initiator_id = atio->initiator_id;
-        pkt->target_id = atio->target_id;
-        pkt->option_flags = atio->option_flags;
-        pkt->tag_value = atio->tag_value;
-        pkt->scsi_status = atio->scsi_status;
-
-        if (len)
-        {
-            pkt->dseg_count = 1;
-            pkt->transfer_length = len;
-            pkt->dseg_0_length = len;
-            dword_ptr = (uint32_t *)addr;
-            pkt->dseg_0_address = *dword_ptr;
-        }
-
-        /* Issue command to ISP */
-        qla1280_isp_cmd(ha);
-    }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (!pkt)
-        qla1280_print("qla1280_32bit_continue_io: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_32bit_continue_io: exiting normally\n\r");
-#endif
-}
-#endif /* QL1280_TARGET_MODE_SUPPORT */
 
 /****************************************************************************/
 /*                        Interrupt Service Routine.                        */
